<xsl:transform
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 version="1.0"
>

<xsl:template match="rectangle" mode="area">
    <xsl:value-of select="@width * @height"/>
</xsl:template>

<xsl:template match="square" mode="area">
    <xsl:value-of select="@side * @side"/>
</xsl:template>

<xsl:template match="circle" mode="area">
    <xsl:value-of select="3.14159 * @radius * @radius"/>
</xsl:template>

<xsl:template name="total-area">
    <xsl:param name="set-of-shapes"/>
    <xsl:choose>
    <xsl:when test="$set-of-shapes">
        <xsl:variable name="first">
            <xsl:apply-templates select="$set-of-shapes[1]" mode="area"/>
        </xsl:variable>
        <xsl:variable name="rest">
            <xsl:call-template name="total-area">
                <xsl:with-param name="set-of-shapes"
                    select="$set-of-shapes[position()!=1]"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:value-of select="$first + $rest"/>
    </xsl:when>
    <xsl:otherwise>0</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="shapes">
    <xsl:call-template name="total-area">
        <xsl:with-param name="set-of-shapes" select="*"/>
    </xsl:call-template>
</xsl:template>


</xsl:transform>
