<xsl:transform
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 version="1.0"
>

<xsl:key name="biog" match="author" use="@name"/>
<xsl:variable name="biogs" select="document('authors.xml')"/>

<xsl:template match="/">
  <html><body>
    <xsl:variable name="all-books" select="//book"/>
    <xsl:for-each select="$all-books">
      <h1><xsl:value-of select="title"/></h1>
      <h2>Author<xsl:if test="count(author)!=1">s</xsl:if></h2>
      <xsl:for-each select="author">
         <xsl:variable name="name" select="."/>
         <h3><xsl:value-of select="$name"/></h3>
         <xsl:for-each select="$biogs">
           <xsl:variable name="auth" select="key('biog', $name)"/>
           <p><xsl:value-of select="concat($auth/born, ' - ', $auth/died)"/></p>
           <p><xsl:value-of select="$auth/biog"/></p>
         </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </body></html>
</xsl:template>

</xsl:transform>

